use new_banks;

set names cp1251;

select @sh_min:=50;
select @sh_sub:=25;

drop table if exists main_comp;
create table main_comp(ticker varchar(10), affiliated smallint, inn bigint, found_aff smallint, ready smallint) character set cp1251 MAX_ROWS=300000000;

load data infile './main.txt' into table main_comp  lines terminated by '\n' ignore 1 lines;


drop table if exists affiliated;
create table affiliated(ticker varchar(10), inn_m bigint, name_a varchar(200),inn_a bigint, share_sub double,
share_owned double, taken2005 smallint) character set cp1251 MAX_ROWS=300000000;

load data infile './affiliated.txt' into table affiliated  lines terminated by '\n' ignore 1 lines;

drop table if exists holdings;
create table holdings(ticker_m varchar(10), inn_m bigint, 
ticker_a varchar(10), inn_a bigint) character set cp1251 MAX_ROWS=300000000;

load data infile './holding.txt' into table holdings  lines terminated by '\n' ignore 1 lines;


drop table if exists tmp0;
create table tmp0(inn bigint) character set cp1251 MAX_ROWS=300000000;
insert into tmp0 select inn from main_comp;
insert into tmp0 select inn_a from affiliated;

drop table if exists tmp_inns;
create table tmp_inns (inn bigint) character set cp1251 MAX_ROWS=300000000;
insert into tmp_inns select inn from tmp0 group by inn;

#drop table if exists tmp_aggr_trans_sp_cl;
#create table tmp_aggr_trans_sp_cl(inn bigint,n_quarter smallint,sp_sum_p double) character set cp1251 MAX_ROWS=300000000;
#insert into tmp_aggr_trans_sp_cl select a.inn, b.n_quarter, b.sp_sum_p from tmp_inns a,
#aggr_trans_sp_cl b where a.inn=b.inn;



#main
drop table if exists tmp1;
create table tmp1(inn bigint, ticker varchar(10), sum_m2003 double,
sum_m2004 double) character set cp1251 MAX_ROWS=300000000;

insert into tmp1 select a.inn, a.ticker, sum(b.sp_sum_p*(n_quarter<5)), sum(b.sp_sum_p*(n_quarter>4)) 
from main_comp a, tmp_aggr_trans_sp_cl b where (a.inn=b.inn) group by a.inn;

#affiliated
drop table if exists tmp2;
create table tmp2(inn bigint, ticker varchar(10), sum_a2003 double,
sum_a2004 double) character set cp1251 MAX_ROWS=300000000;
insert into tmp2 select a.inn_m, a.ticker, sum(b.sp_sum_p*(n_quarter<5)), sum(b.sp_sum_p*(n_quarter>4)) 
from affiliated a, tmp_aggr_trans_sp_cl b where (a.inn_a=b.inn) and (a.inn_a<>a.inn_m) and 
(a.share_owned>@sh_min) and ( a.share_sub<@sh_sub) group by a.inn_m;


#???
drop table if exists tmp2s;
create table tmp2s(inn bigint,inn_a bigint, ticker varchar(10), sum_a2003 double,
sum_a2004 double) character set cp1251 MAX_ROWS=300000000;
insert into tmp2s select a.inn_m, a.inn_a, a.ticker, sum(b.sp_sum_p*(n_quarter<5)), sum(b.sp_sum_p*(n_quarter>4)) 
from affiliated a, tmp_aggr_trans_sp_cl b where (a.inn_a=b.inn) and (a.inn_a<>a.inn_m) and 
(a.share_owned>@sh_min) and ( a.share_sub<@sh_sub) group by a.inn_m, a.inn_a;




#inn for holdings
drop table if exists tmp_inn;
create table tmp_inn(inn_m bigint, inn_a bigint)  character set cp1251 MAX_ROWS=300000000;
insert into tmp_inn select inn_m, inn_a from affiliated where (share_owned>@sh_min) and ( share_sub<@sh_sub);
insert into tmp_inn select inn_m, inn_a from holdings;
insert into tmp_inn select a.inn_m, b.inn_a from holdings a, affiliated b where (a.inn_a=b.inn_m) 
and ( b.share_owned>@sh_min) and ( b.share_sub<@sh_sub);


drop table if exists tmp_inn1;
create table tmp_inn1(inn_m bigint, inn_a bigint)  character set cp1251 MAX_ROWS=300000000;
insert into tmp_inn1 select * from tmp_inn where (inn_m<>inn_a) group by inn_m, inn_a;

drop table if  exists tmp2a;
create table tmp2a(inn bigint, sum_h2003 double not null default 0,
sum_h2004 double not null default 0) character set cp1251 MAX_ROWS=300000000;
insert into tmp2a select a.inn_m,  sum(b.sp_sum_p*(n_quarter<5)), sum(b.sp_sum_p*(n_quarter>4))
from tmp_inn1 a, tmp_aggr_trans_sp_cl b where (a.inn_a=b.inn) group by a.inn_m;

drop table if exists tmp_holding_inns;
create table tmp_holding_inns( inn bigint, ticker varchar(10), fl smallint) character set cp1251 MAX_ROWS=300000000;
insert into tmp_holding_inns select a.inn, a.ticker,  sum(a.inn=b.inn_a) from main_comp a, holdings b  group by a.inn;



drop table if exists holding_inns;
create table holding_inns( inn bigint, ticker varchar(10)) character set cp1251 MAX_ROWS=300000000;
insert into holding_inns select a.inn, a.ticker from tmp_holding_inns a where fl=0;


drop table if  exists tmp3;
create table tmp3(inn bigint, ticker varchar(10), sum_h2003 double not null default 0,
sum_h2004 double not null default 0) character set cp1251 MAX_ROWS=300000000;

insert into tmp3 select a.inn, a.ticker, b.sum_h2003, b.sum_h2004 from holding_inns a left join (tmp2a b) 
on (a.inn=b.inn);


drop table if exists tmp4;
create table tmp4(inn bigint, ticker varchar(10), sum_m2003 double,
sum_m2004 double) character set cp1251 MAX_ROWS=300000000;

insert into tmp4 select a.inn, a.ticker, b.sum_m2003, b.sum_m2004
from main_comp a left join (tmp1 b) on (a.inn=b.inn);

drop table if exists tmp4a;
create table tmp4a(inn bigint, ticker varchar(10), sum_m2003 double,
sum_m2004 double, 
sum_a2003 double, sum_a2004 double) character set cp1251 MAX_ROWS=300000000;

insert into tmp4a select a.inn, a.ticker, a.sum_m2003, a.sum_m2004,
c.sum_a2003, c.sum_a2004 from
tmp4 a left join (tmp2 c) on  (a.inn=c.inn);




drop table if exists tax_evasion_big;
create table tax_evasion_big(inn bigint, ticker varchar(10), sum_m2003 double,
sum_m2004 double, sum_a2003 double, sum_a2004 double,
um_h2003 double,sum_h2004 double) character set cp1251 MAX_ROWS=300000000;

insert into tax_evasion_big select a.inn, a.ticker, a.sum_m2003, a.sum_m2004,
a.sum_a2003, a.sum_a2004, d.sum_h2003, d.sum_h2004 from
tmp4a a left join (tmp3 d) on (a.inn=d.inn);


drop table if exists tmp_affiliated_all;
create table tmp_affiliated_all(ticker varchar(10), inn_m bigint, inn_a bigint, name_a varchar(200), share_sub double,
share_owned double, sum2003 double, sum2004 double) character set cp1251 MAX_ROWS=300000000;

insert into tmp_affiliated_all select a.ticker, a.inn_m, a.inn_a, name_a,share_sub,share_owned, sum(b.sp_sum_p*(n_quarter<5)), sum(b.sp_sum_p*(n_quarter>4)) 
from affiliated a, tmp_aggr_trans_sp_cl b where (a.inn_a=b.inn) and (a.inn_a<>a.inn_m) group by a.inn_m, inn_a;


insert into tmp_affiliated_all select a.ticker, a.inn, a.inn, " ",100,100, sum(b.sp_sum_p*(n_quarter<5)), sum(b.sp_sum_p*(n_quarter>4)) 
from affiliated a, tmp_aggr_trans_sp_cl b where (a.inn=b.inn) group by a.inn;



select  * from tax_evasion_big  into outfile './tax_evasion.txt' fields terminated by '`' ;
 
select a.ticker, a.inn_m, a.inn_a, name_a,share_sub,share_owned, sum(b.sp_sum_p*(n_quarter<5)), sum(b.sp_sum_p*(n_quarter>4)) 
from affiliated a, tmp_aggr_trans_sp_cl b where (a.inn_a=b.inn) and (a.inn_a<>a.inn_m) group by a.inn_m, inn_a 
 into outfile './tax_affiliated.txt' fields terminated by '`'

select a.*,b.inn_r, c.name, sum(b.sum*(n_quarter<5)), sum(b.sum*(n_quarter>4)) 
from tmp_affiliated_all a, sp_trans_p_r b, agents_inn  c where (a.inn_a=b.inn_p) and (b.inn_r=c.inn) group by a.inn_a, b.inn_r
 into outfile './tax_affiliated_sp.txt' fields terminated by '`'


