use new_banks;

set names cp1251;

select @min_tr:=10;
select @datbase:='2002-12-31';

drop table if exists regions_sp;
create table regions_sp(reg int,sum2003_d double,sum2004_d double,
sum2003_s double,sum2004_s double) character set cp1251 MAX_ROWS=300000000;
insert into regions_sp select
reg, sum((sum_r-sum_p)*sp*(n_quarter<=4)), sum((sum_r-sum_p)*sp*(n_quarter>4)),
sum((sp_sum_p-sp_sum_r)*(n_quarter<=4)), sum((sp_sum_p-sp_sum_r)*(n_quarter>4))

from  aggr_trans_sp_cl a, regions_inn b where (a.inn=b.inn) group by reg;

drop table if exists tmp;
create table tmp(inn bigint, gov smallint, invest smallint, not_fin smallint,
mgup smallint, primary key(inn)) character set cp1251 MAX_ROWS=300000000;

insert into tmp select a.inn, (a.gov>0), 
((b.invest+b.broker+b.strah)>0) and (a.gov=0) and ((b.bank+b.kb)=0)and (mgup=0)and (inostr=0),
((b.invest+b.broker+b.strah)=0) and (a.gov=0) and ((b.bank+b.kb)=0) and 
(b.fond=0)and (inostr=0) and ( (b.oao+ b.ooozao)>0) and (mgup=0),
(mgup=1) and (a.gov=0) from agents_inn a, agents_3 b where (a.id_c=b.id);


drop table if exists summary_sp;
create table summary_sp(n_quarter smallint, sum_total double , sum_gov double, sum_invest double,
sum_not_fin double,sum_mgup double) character set cp1251 MAX_ROWS=300000000;

insert into summary_sp select n_quarter, sum(sp_sum_p-sp_sum_r),sum((sp_sum_p-sp_sum_r)*gov),
sum((sp_sum_p-sp_sum_r)*invest*(sp=0)),sum((sp_sum_p-sp_sum_r)*not_fin*(sp=0)), sum((sp_sum_p-sp_sum_r)*mgup*(sp=0))
from aggr_trans_sp_cl a, tmp b where (a.inn=b.inn) group by n_quarter;

select  * from regions_sp into outfile './regions_sp.txt' fields terminated by '`' ;
select  * from summary_sp into outfile './summary_sp.txt' fields terminated by '`' ;




